# write a comma-separated (spreadsheet-format) file

lappend command(writetypes) ".csv (Spreadsheet)"
lappend command(writeproc) writelistcsv

proc writelistcsv {data} {
    global graph command
    global $data 
    set filename [file join $command(pwd) ${data}.csv]
    set fil [open $filename w]
    if {[set ${data}(type)] == "peaks"} {
	# write a peak file
	puts $fil "CMPR peaks file"
	puts $fil [set ${data}(title)]
	if {[set ${data}(xunits)] == "dspace"} {
	    puts $fil "dspace, intensity, width, background, eta"
	} elseif {[set ${data}(xunits)] == "Q"} {
	    puts $fil "Q, intensity, width, background, eta"
	} elseif {[set ${data}(xunits)] == "TOF"} {
	    puts $fil "TOF, intensity, width, background, eta"
	} else {
	    set wave [set ${data}(wavelength)]
	    puts $fil "2theta, intensity, width, height, background, eta, wave=$wave"
	} 
	foreach x   [set ${data}(x)] \
	    y   [set ${data}(y)] \
	    wid [set ${data}(widths)] \
	    eta [set ${data}(etas)] \
	    h [set ${data}(heights)] \
	    bkg [set ${data}(bkgs)] {
		puts $fil "$x, $y, $wid, $h, $bkg, $eta"
	    }
    } else {
	# write a data file
	puts $fil "twotheta, intensity, esd"
	if {$command(writeunits) == 0} {
	    foreach x   [set ${data}(x)] \
		    y   [set ${data}(y)] \
		    esd [set ${data}(esd)] {
		puts $fil "$x, $y, $esd"
	    }
	} else {
	    foreach x   [[set ${data}(xvector)] range 0 end] \
		    y   [[set ${data}(yvector)] range 0 end] \
		    esd [[set ${data}(esdvec)]  range 0 end] {
		puts $fil "$x, $y, $esd"
	    }
	}
     }
    close $fil
    return $filename
}
